(function ($) {
  modalShown = false,
    this.pudoShowModal = function () {
      if (!this.modalShown) {
        pudoModal.style.display = 'block'
        map.invalidateSize()
        modalShown = true
      }
    },
    this.setDestinationLocker = function (code, title) {
      //Trigger update
      //$('input[name="shipping_method[0]"]').val('l2l-pudo');
      //$('#2l-pudo').val('l2l-pudo');
      $('#pudo-locker-destination-name').val(title)
      $('#pudo-locker-origin-name').val($('#pudo-locker-origin option:selected').text())

      $('#pudo-locker-destination').val(code)
      $('body').trigger('update_checkout')
      pudoModal.style.display = 'none'

      $('tfoot')[0].hidden = false
      pudoModal.style.display = 'none'

    }, $(function () {
    //(Checkout)
    //Fire update checkout on change
    $('form.checkout').on('change', 'input[name="shipping_method[0]"]', function () {
      modalShown = false
      $('body').trigger('update_checkout')
    })

    //Add markers to the map
    function addMarker(title, code, lat, lng, markers) {
      //Define marker object
      if (!lat || !lng) {
        return
      }
      if (lat == '.,') {
        return
      }
      if (lat == '.') {
        return
      }

      //Define custom icon properties
      let customIcon = {
        //iconUrl: "/wp-content/plugins/woocom-pudo/dist/icon_pudo.png",
        iconUrl: window.location.origin + '/wp-content/plugins/Woocom - Pudo/dist/icon_pudo.png',
        iconSize: [30, 50]
      }
      //Create icon object
      let myIcon = L.icon(customIcon)

      //Icon options
      let iconOptions = {
        icon: myIcon
      }
      var p = L.marker([lat, lng], iconOptions)

      //Set marker properties
      p.title = title
      p.alt = title
      //Define popupContent with onClick functions to manage Pickup/Delivery location
      popupContent =
        '<button type=\'button\' class=\'btn btn-primary\' onclick=\'setDestinationLocker("' + code + '","' + title + '");\'>' +
        '<span class=\'pnomobile\'>Select </span>' + title + ' <span class=\'pnomobile\'>as the Delivery Locker</span>' +
        '</button>'

      //Bind the generated popupContent to the marker
      p.bindPopup(popupContent)
      //Finally add the marker to the map
      //p.addTo(map);
      //Set the name as a tooltip and Open it up so user can see what location is what marker
      p.bindTooltip(title, {}).openTooltip()
      markers.addLayer(p)
      addRowTable(code, [lat, lng], title)
    }

    //Add rows to table
    function addRowTable(code, coords, title) {
      var tr = document.createElement('tr')
      var td = document.createElement('td')
      td.style.width = '500px'
      td.textContent = title
      tr.appendChild(td)
      tr.onclick = function () {
        var tableRows = document.getElementById('t_points').getElementsByTagName('tr')
        for (var i = 0; i < tableRows.length; i++) {
          var row = tableRows[i]
          var cells = row.getElementsByTagName('td')
          for (var j = 0; j < cells.length; j++) {
            var cell = cells[j]
            if (cell !== td) {
              var button = cell.querySelector('button')
              if (button) {
                var cellTitle = button.getAttribute('data-title')
                cell.innerHTML = cellTitle
                cell.style.padding = '8px 10px'
              }
            }
          }
        }

        var button = td.querySelector('button')
        if (button) {
          // Button is already present, so remove it and revert the title
          var buttonTitle = button.getAttribute('data-title')
          td.innerHTML = buttonTitle
          td.style.padding = '8px 12px !important'
        } else {
          // Button is not present, add it and perform the flyTo action
          map.flyTo(coords, 15, { duration: 2 })
          td.innerHTML = '<button style=\'font-size:16px;text-align:left;width:100%;padding: 8px 10px;\' onclick=\'setDestinationLocker("' + code + '","' + title + '");\' data-title=\'' + title + '\'>Select ' + title + '</button>'
          td.style.overflow = 'hidden'
          td.style.padding = '0px'
        }
      }
      document.getElementById('t_points').appendChild(tr)
    }

    //Hide any ".hide" classes
    $('.hide').prop('hidden', true)

    let pictureUrl = window.location.origin + '/wp-content/plugins/Woocom - Pudo/dist/icon_pudo.png'

    //Add the pudoModalto the body of the app
    $('body').append(
      '<div id="pudoModal" class="pudo-modal">' +
      '<div class="pudo-modal-content">' +
      '<span class="pudo-close">&times;</span>' +
      '<div id="pudo-wrapper">' +
      '<div id="pudo-first">' +
      '<h4 class="pudo-h4" id="pudo-modalTitle" style="text-align: left;"><img src="' + pictureUrl + '" class="pudo-marker-title" > &nbsp; PUDO Shipping</h4>' +
      '<p class="pnodesktop pudo-modal-desc"> &nbsp; Select a locker for delivery</p>' +
      '<div id="pudo-table-container" style="display:inline-block">' +
      '<table class="table table-bordered" style="display:inline-block" id="table">' +
      '<thead>' +
      '<tr>' +
      '<th>Pudo Lockers</th>' +
      '</tr>' +
      '</thead>' +
      '<tbody id="t_points"></tbody>' +
      '</table>' +

      '</div>' +
      '</div>' +
      '<div id="pudo-map-container">' +
      '<div id="pudo-map" style="display:inline-block width: 100%;" class=""></div>' +
      '</div>' +
      '</div>' +
      '</div>' +
      '</div>'
    )

    //Define map object
    var mapElement = document.getElementById('pudo-map')
    var currencyLabel = document.getElementById('pricing_options-description');
    //Check type of control
    if (currencyLabel === null && mapElement !== null) {
      map = L.map('pudo-map').setView([-27.9150338, 24.8737837], 6)
      //Fetch tile layer (OSM)
      L.tileLayer('//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png').addTo(map)
    }
    //Define provider
    $(document).ready(function () {
      // Add select2 to pudo selector
      const $lockerOrigin = $('#pudo-locker-origin')
      const $lockerDestination = $('#pudo-locker-destination')
      //Check what type of control is used to select locker
      //If the map is not used, initialize select2 on the element
      if ($lockerDestination[0]) {
        $lockerDestination.select2()
      }

      if (map != null) {

        // Get the modal
        pudoModal = document.getElementById('pudoModal')

        // Get the button that opens the modal
        // Get the <span> element that closes the modal
        var span = document.getElementsByClassName('pudo-close')[0]

        // When the user clicks on <span> (x), close the modal
        span.onclick = function () {
          pudoModal.style.display = 'none'
        }

      } else {
        $lockerOrigin.select2()
        // Hide/Show address  fields based on selection of shipping type
      }

      if (map != null) {
        var markers = L.markerClusterGroup({ chunkedLoading: true })
        var points = markersJSON
        //Add the markers to the map and table on left of map
        for (var i = 0; i < points.length; i++) {
          addMarker(points[i]['name'], points[i]['id'], points[i]['latitude'], points[i]['longitude'], markers)
        }
        map.addLayer(markers)

        //Assign on change function to each of the markers
        $('#range').change(function (e) {
          var radius = parseInt($(this).val())
          markers.forEach(function (e) {
            e.setRadius(radius)
            e.addTo(map)

          })
        })
        //Initialize data tables
        $('#table').DataTable({
          responsive: false,
          'bInfo': false,
          'bLengthChange': false,
          pagingType: 'full',
          pageLength: 6,
          language: {
            search: '_INPUT_',
            searchPlaceholder: 'Search'
          }
        })
        //Hide pagination, table length and info on map modal
        $('#table').find('.dataTables_paginate, .dataTables_length, .dataTables_info').hide()

        //Hide the tool tips on map
        map.eachLayer(function (layer) {
          if (layer.options.pane === 'tooltipPane') layer.removeFrom(map)
        })

      }
    })
  })

})(jQuery)
